<?php 
/* ----------------------------------------------------------------------------- 
Plugin Name: PixGallery
Version: 0.1.8
Plugin URI: http://www.nathanm.com/index.php/pixgallery/
Description: Hooks up all my pics foo.
Author: Nathan Moinvaziri
Author URI: http://www.nathanm.com/

See pixgallery.txt for release notes

 ------------------------------------------------------------------------------- */ 
/* Get query values 
/* ------------------------------------------------------------------------------ */

$PhotoId		= (isset($_REQUEST['photo_id']) == TRUE)		? $_REQUEST['photo_id']		: FALSE;
$CollectionId	= (isset($_REQUEST['gallery_id']) == TRUE)		? $_REQUEST['gallery_id']	: 0;
$Collections	= null;

if (ini_get('safe_mode') == FALSE)
	set_time_limit(0); // Give enough time for thumbnails to create

if (ini_get('allow_url_fopen') != '1')
	@ini_set('allow_url_fopen', '1');

/* ------------------------------------------------------------------------------ */
/* Default settings for plugin 
/* ------------------------------------------------------------------------------ */

$PixGallery_Columns					= '3'; 
$PixGallery_Rows					= '0'; 
$PixGallery_ImageWidth				= '150';
$PixGallery_ImageHeight				= '100';
$PixGallery_ImageHeightLarge		= '0';
$PixGallery_ImageWidthLarge			= '600';
$PixGallery_ImageStyle				= "border: 1px solid #eeeeee; padding: 4px;"; 
$PixGallery_ImageStyleGlobal		= "border: 1px solid #eeeeee; padding: 4px;"; 
$PixGallery_RootPhotos				= "/images/photos/"; 
$PixGallery_RootCache				= "/images/cache/"; 
$PixGallery_ReduceOriginalsWidth	= '1024';
$PixGallery_ReduceOriginalsHeight	= '768';
$PixGallery_PopupMethod				= 'Layer';

/* The folder paths below are automatically determined by PixGallery_DeterminePaths */

$PixGlobal_Version					= '0.1.9';
$PixGlobal_Url						= "http://www.lonelyfridge.com"; 
$PixGlobal_RootWebsite				= "/home/lonelyfridge/lonelyfridge.com"; 

/* ------------------------------------------------------------------------------ */
/* Load settings from database 
/* ------------------------------------------------------------------------------ */

PixGallery_DeterminePaths();
PixGallery_Options_Load();

/* ------------------------------------------------------------------------------ */
/* General purpose functions
/* ------------------------------------------------------------------------------ */

function PixGallery_PrintError($ErrorMessage)
{
	print("<span class=\"error\">".$ErrorMessage."</error><br />");
}

function PixGallery_UrlGetFileExtension($Url)
{
	$FileName = PixGallery_UrlGetFileName($Url);

	if (strrpos($FileName, ".") === FALSE)
		return $FileName;

	return substr($FileName, strrpos($FileName, "."));
}

function PixGallery_UrlGetFileTitle($Url)
{
	$FileName = PixGallery_UrlGetFileName($Url);

	if (strrpos($FileName, ".") === FALSE)
		return $FileName;

	return substr($FileName, 0, strrpos($FileName, "."));
}

function PixGallery_UrlGetFileName($Url)
{
	$Url = str_replace("\\", "/", $Url);

	if (strrpos($Url, "/") === FALSE)
		return $Url;

	return substr($Url, strrpos($Url, "/") + 1);
}

function PixGallery_UrlGetFilePath($Url)
{
	$PathEnd = strrpos($Url, '/');
	if ($PathEnd !== FALSE) 
	{
		$PathEnd += 1;
		$ProtocolStart	= strpos($Url, "://");
		if ($ProtocolStart != FALSE)
		{
			$ProtocolStart += 3;		
			$Url = substr($Url, $ProtocolStart);
			$PathEnd = strrpos($Url, '/');
		}

		$PathStart = strpos($Url, '/');


		$Url = substr($Url, $PathStart, $PathEnd - $PathStart);
	}
	return $Url;
}
function MakeDirectory($dir, $mode = 0755)
{ 
/*
http://ca3.php.net/manual/en/function.mkdir.php

How it works: line one attempts to make the directory, and returns TRUE if it works or if 
it already exists.  That's the easy case if the parent directories all exist.

Line two trims off the last directory name using dirname(), and calls MakeDirectory recursively 
on that shorter directory.  If that fails, it returns FALSE, but otherwise we come out of it 
knowing that the parent directory definitely exists.

Finally, presuming the recursive call worked, once we get to line three we can create the 
requested directory.

Note the use of @ to suppress warning messages from mkdir.

The beauty of this is that if, say, the great-grandparent directory exists but the grandparent 
and parent directories don't, the function will simply call itself recursively until it gets 
high enough up the tree to do some work, then carry on unwinding back until all the new 
directories have been created.

This is pretty bog-standard recursive programming.  Anyone who can't wrap their head around it 
after a few minutes of concentration should probably try a career in sales.

*/
	//@ - surpresses warnings
	if (is_dir($dir) || @mkdir($dir,$mode)) 
	{
		return TRUE;
	}
	if (!MakeDirectory(dirname($dir),$mode)) 
	{
		return FALSE;
	}
	return @mkdir($dir,$mode);
}
function PixGallery_UrlGetPath($Url)
{
	$PathSplit = "/";

	$PathEnd = strrpos($Url, $PathSplit);
	$ProtocolStart	= strpos($Url, "://");

	if ($PathEnd === FALSE) {
		return $PathSplit;
	}
	
	$PathEnd += 1;

	if ($ProtocolStart != FALSE)
		{
		$ProtocolStart += 3;		
		$Url = substr($Url, $ProtocolStart);
		$PathEnd = strrpos($Url, $PathSplit);
		}

	$PathStart = strpos($Url, $PathSplit);
	
	if ($PathStart === FALSE)
		return $PathSplit;

	$Url = substr($Url, $PathStart, $PathEnd - $PathStart);

	return $Url;
}

function PixGallery_UrlBuild($Name, $Value = "")
{
	global $PixGlobal_Url;

	$NewUrl		= $PixGlobal_Url."?";
	$Query		= $_SERVER['QUERY_STRING']."&";
	$Queries	= explode("&", $Query);
	$Added		= FALSE;

	for ($x = 0; ($x != count($Queries)) && ($Added == FALSE); $x++)
	{
		list($QueryName, $QueryValue) = explode("=", $Queries[$x]);
		if ($QueryName == $Name)
		{
			if ($Value !== "") 
			{
				$NewUrl .= "&$QueryName=$Value";
			}

			$Added	= TRUE;
		}
		else if ($QueryValue != "")
		{
			$NewUrl .= "&$QueryName=$QueryValue";
		}
	}

	if ($Added == FALSE) 
	{
		$NewUrl .= "&$Name=$Value";
	}

	return trim(str_replace("?&", "?", $NewUrl), "?");
}

function PixGallery_DeterminePaths()
{
	global $PixGlobal_Url, $PixGlobal_RootWebsite;

	$ScriptFile = $_SERVER['SCRIPT_FILENAME'];
	//echo '<h1>$ScriptFile: '.$ScriptFile.'</h1>';

	if (isset($_SERVER['DOCUMENT_ROOT']))
		$PixGlobal_RootWebsite = $_SERVER['DOCUMENT_ROOT'];
	else
		$PixGlobal_RootWebsite = substr($ScriptFile, 0 , (strlen($ScriptFile) - strlen($_SERVER['PHP_SELF'])) + 1);

	//echo '<h1>$PixGlobal_RootWebsite: '.$PixGlobal_RootWebsite.'</h1>';

	/*
	//WINDOWS
	if ($PixGlobal_RootWebsite[strlen($PixGlobal_RootWebsite) - 1] != "\\")
		$PixGlobal_RootWebsite .= "\\";
		
	*/
	/*
	//LINUX
	if ($PixGlobal_RootWebsite[strlen($PixGlobal_RootWebsite) - 1] != "/")
		$PixGlobal_RootWebsite .= "/";
	*/
	//echo '<h1>$PixGlobal_RootWebsite: '.$PixGlobal_RootWebsite.'</h1>';

	if (isset($_SERVER['REQUEST_URI']))
		$PixGlobal_Url = PixGallery_UrlGetPath($_SERVER['REQUEST_URI']);
	else
		$PixGlobal_Url = PixGallery_UrlGetPath($_SERVER['PHP_SELF']);
}

/* ------------------------------------------------------------------------------ */
/* Image functions, html parsing
/* ------------------------------------------------------------------------------ */

	function PixGallery_ImageCalculateSizeLarge($ImageFile)
	{
		global $PixGallery_ImageWidthLarge, $PixGallery_ImageHeightLarge;

		return PixGallery_ImageCalculateSize($ImageFile, $PixGallery_ImageWidthLarge, $PixGallery_ImageHeightLarge);
	}

	function PixGallery_ImageCalculateSizeSmall($ImageFile)
	{
		global $PixGallery_ImageWidth, $PixGallery_ImageHeight;

		return PixGallery_ImageCalculateSize($ImageFile, $PixGallery_ImageWidth, $PixGallery_ImageHeight);
	}

	function PixGallery_ImageCalculateSize($ImageFile, $MaximumWidth, $MaximumHeight)
	{
		$ImageObject		= getimagesize($ImageFile);

		$ImageWidth			= $MaximumWidth;
		$ImageHeight		= $MaximumHeight;

		$ImageRealWidth		= $ImageObject[0];
		$ImageRealHeight	= $ImageObject[1];

		if ($ImageRealWidth == 0) {
			$ImageRealWidth = 1;
		}
		if ($ImageRealHeight == 0) {
			$ImageRealHeight = 1;
		}

		$ImagePercentWidth	= ($ImageWidth / $ImageRealWidth);
		$ImagePercentHeight = ($ImageHeight / $ImageRealHeight);

		if ($MaximumWidth == 0)
			$MaximumWidth = FALSE;
		if ($MaximumHeight == 0)
			$MaximumHeight = FALSE;

		if (strpos($MaximumWidth, "px") !== FALSE)
			$MaximumWidth = str_replace("px", "", $MaximumWidth);
		if (strpos($MaximumHeight, "px") !== FALSE)
			$MaximumHeight = str_replace("px", "", $MaximumHeight);

		if ($MaximumWidth !== FALSE && $MaximumHeight === FALSE)
			{
			if (strpos($MaximumWidth, "%") !== FALSE)
				{
				$ImagePercentWidth	= (intval(str_replace("%", "", $MaximumWidth)) / 100);
				$ImageWidth			= round($ImageRealWidth * $ImagePercentWidth);
				}
			else
				$ImageWidth	= round($ImageRealWidth * $ImagePercentWidth);

			if ($ImageRealWidth < $ImageWidth)
				{
				$ImageWidth		= $ImageRealWidth;
				$ImageHeight	= $ImageRealHeight;
				}
			else
				$ImageHeight	= round($ImageRealHeight * $ImagePercentWidth);
			}
		else if ($MaximumWidth === FALSE && $MaximumHeight !== FALSE)
			{
			if (strpos($MaximumHeight, "%") !== FALSE)
				{
				$ImagePercentHeight	= (intval(str_replace("%", "", $MaximumHeight)) / 100);
				$ImageHeight		= round($ImageRealHeight * $ImagePercentHeight);
				}
			else
				$ImageHeight	= round($ImageRealHeight * $ImagePercentHeight);

			if ($ImageRealHeight < $ImageHeight)
				{
				$ImageWidth		= $ImageRealWidth;
				$ImageHeight	= $ImageRealHeight;
				}
			else
				$ImageWidth		= round($ImageRealWidth * $ImagePercentHeight);
			}
		else if ($MaximumWidth !== FALSE && $MaximumHeight !== FALSE)
			{
			if ($ImageRealWidth < $ImageWidth)
				$ImageWidth = $ImageRealWidth;

			$ImageHeight = round(($ImageWidth / $ImageRealWidth) * $ImageRealHeight);

			if ($ImageHeight > $MaximumHeight)
				{
				$ImageHeight	= $MaximumHeight;
				$ImageWidth		= round(($ImageHeight / $ImageRealHeight) * $ImageRealWidth);
				}
			}
		else if ($MaximumWidth === FALSE && $MaximumHeight === FALSE)
			{
			$ImageWidth		= $ImageRealWidth;
			$ImageHeight	= $ImageRealHeight;
			}

		return array('Width' => $ImageWidth, 'Height' => $ImageHeight);
	}

	/* Set or get the an html tag attribute */

	function PixGallery_ImageHtmlAttribute($TagContents, $AttributeName, $AttributeValue = FALSE)
	{
		$TagContentsLower	= strtolower($TagContents);
		$AttributeNameLower	= strtolower($AttributeName);

		$AttributeStart = strpos($TagContentsLower, $AttributeNameLower);
		
		if ($AttributeStart === FALSE)
			return FALSE;
		
		$AttributeStart = strpos($TagContentsLower, "=", $AttributeStart);

		while ($TagContents[$AttributeStart++] == ' ');

		$FindEndChar = ' ';

		if ($TagContents[$AttributeStart] == '\'')
			$FindEndChar = '\'';
		if ($TagContents[$AttributeStart] == '"')
			$FindEndChar = '"';
		
		$AttributeEnd = strpos($TagContentsLower, $FindEndChar, $AttributeStart + 1);
		
		if ($FindEndChar != ' ')
			{
			while ($TagContents[$AttributeEnd - 1] == '\\')
				$AttributeEnd = strpos($TagContentsLower, $FindEndChar, $AttributeEnd + 1);

			$AttributeStart++;
			}

		if ($AttributeEnd == FALSE)
			$AttributeEnd = strlen($TagContents);

		if ($AttributeValue == FALSE)
			{
			$AttributeValue = substr($TagContents, $AttributeStart, $AttributeEnd - $AttributeStart);

			return $AttributeValue;
			}

		$NewTagContents = substr($TagContents, 0, $AttributeStart);
		$NewTagContents.= $AttributeValue;
		$NewTagContents.= substr($TagContents, $AttributeEnd);

		return $NewTagContents;
	}

	function PixGallery_ImageReduce($ImageFileName)
	{
		global $PixGallery_ReduceOriginalsWidth, $PixGallery_ReduceOriginalsHeight;

		$MaximumWidth	= $PixGallery_ReduceOriginalWidth;
		$MaximumHeight	= $PixGallery_ReduceOriginalHeight;

		if ($MaximumWidth == 0)
			return FALSE;

		$ImageInfo		= getimagesize($ImageFileName);
		$ImageObject	= FALSE;

		$ImageWidth		= $ImageInfo[0];
		$ImageHeight	= $ImageInfo[1];
		$ImageFileSize	= @filesize($ImageFileName);
		
		if ($ImageFileSize == FALSE)
			{
			PixGallery_PrintError("Error: Photos path must have write permission for reduce originals option!");
			return FALSE;
			}	

		if ($ImageWidth > $MaximumWidth)
			{
			$NewImageSize	= PixGallery_ImageCalculateSize($ImageFileName, $MaximumWidth, $MaximumHeight);

			$NewImageWidth	= $NewImageSize['Width'];
			$NewImageHeight	= $NewImageSize['Height'];

			PixGallery_ImageResize($ImageFileName, $NewImageWidth, $NewImageHeight, $ImageFileName.".tmp");

			unlink($ImageFileName);
			copy($ImageFileName.".tmp", $ImageFileName);
			unlink($ImageFileName.".tmp");
			}

		return TRUE;
	}

	function PixGallery_ImageResize($ImageFileName, $NewImageWidth, $NewImageHeight, $NewImageFile = FALSE)
	{
		global $PixGlobal_RootWebsite, $PixGallery_RootCache;
		
		if ($NewImageFile == FALSE)
			{
			$ImagePath = PixGallery_UrlGetFilePath($ImageFileName);
			$NewImagePath = substr($ImagePath, strpos($ImagePath, $PixGlobal_RootWebsite) + strlen($PixGlobal_RootWebsite) + 1);
			$NewImageTitle		= PixGallery_UrlGetFileTitle($ImageFileName);
			$NewImageExtension	= PixGallery_UrlGetFileExtension($ImageFileName);
			$NewImageTitle		.= '_'.$NewImageWidth.'x'.$NewImageHeight;
			$NewImageTitle		= rawurldecode($NewImageTitle);
			MakeDirectory($PixGlobal_RootWebsite.$PixGallery_RootCache.$NewImagePath);
			$NewImageFile		= $PixGlobal_RootWebsite.$PixGallery_RootCache.$NewImagePath.$NewImageTitle.$NewImageExtension;

			if (file_exists($NewImageFile))
				return $NewImageFile;
			}

		$ImageInfo		= getimagesize($ImageFileName);
		$ImageObject	= FALSE;

		switch ($ImageInfo['mime']) 
			{
			case 'image/gif':
				if (imagetypes() & IMG_GIF) 
					$ImageObject = imagecreatefromgif($ImageFileName);
				break;
			case 'image/jpeg':
				if (imagetypes() & IMG_JPG) 
					$ImageObject = imagecreatefromjpeg($ImageFileName);
				break;
			case 'image/png':
				if (imagetypes() & IMG_PNG) 
					$ImageObject = imagecreatefrompng($ImageFileName);
				break;
			case 'image/wbmp':
				if (imagetypes() & IMG_WBMP) 
				$ImageObject = imagecreatefromwbmp($ImageFileName);
				break;
			default:
				echo "Image format not supported [".$ImageInfo['mime']."]";
				break;
			}

		if ($ImageObject == FALSE)
			return FALSE;

		$RealImageWidth		= $ImageInfo[0];
		$RealImageHeight	= $ImageInfo[1];

		if ($RealImageWidth < $NewImageWidth)
			return $ImageFileName;

		$NewImageObject = imagecreatetruecolor($NewImageWidth, $NewImageHeight);
	   
		imagecopyresampled($NewImageObject, $ImageObject, 0, 0, 0, 0, $NewImageWidth, $NewImageHeight, $RealImageWidth, $RealImageHeight);

		imagejpeg($NewImageObject, $NewImageFile, 100);
	  
		imagedestroy($ImageObject);
		imagedestroy($NewImageObject);

		return $NewImageFile;
	}

	function PixGallery_Image($Html)
	{
		global $PixGlobal_RootWebsite, $PixGallery_PopupMethod, $PixGallery_ImageStyleGlobal;

		/* Begin parsing html looking for images */

		$HtmlLower = strtolower($Html);
		$NewHtml = "";

		$TagName = "img";
		$TagBeginPrev = 0;
		$TagBegin = 0;
		$TagEnd	= 0;

		$stillLooking = true;
		while ($stillLooking) 
		{
			$TagBegin = strpos($HtmlLower, "<$TagName", $TagEnd);

			$TagEnd	= strpos($HtmlLower, " />", $TagBegin);
			//echo "<p>begin: $TagBegin end: $TagEnd</p>\n";

			if ($TagBegin === FALSE || $TagEnd === FALSE)
			{
				$stillLooking = FALSE;
			}
			else
			{

				$TagBegin += (strlen($TagName) + 1);
				$TagContents = substr($Html, $TagBegin, $TagEnd - $TagBegin); 
				$NewHtml .= substr($Html, $TagBeginPrev, $TagBegin - $TagBeginPrev);
				$TagBeginPrev = $TagBegin;

				$ImageSource = PixGallery_ImageHtmlAttribute($TagContents, 'src');
				$ImageClass = PixGallery_ImageHtmlAttribute($TagContents, 'class');
				$ImageTitle = PixGallery_ImageHtmlAttribute($TagContents, 'title');


				if ($ImageSource !== FALSE AND strpos($ImageClass, "usePixGallery", 0) !== FALSE)
				{
					$ImageWidth = PixGallery_ImageHtmlAttribute($TagContents, 'width');
					$ImageHeight = PixGallery_ImageHtmlAttribute($TagContents, 'height');

					if ($ImageWidth == "")	
						$ImageWidth = FALSE;
					else
						$ImageWidth = str_replace("px", "", $ImageWidth);

					if ($ImageHeight == "")	
						$ImageHeight = FALSE;
					else
						$ImageHeight = str_replace("px", "", $ImageHeight);

					$ImageNewPath		= "";
					$ImagePath			= $ImageSource;

					if (strpos($ImageTitle, "(click to enlarge)") === FALSE) {
						$ImageTitle .= "(click to enlarge)";
					}

					if (strpos($ImagePath, "://") === FALSE) {
						$ImagePath = $PixGlobal_RootWebsite.$ImagePath;
					}

					PixGallery_ImageReduce($ImagePath); /* Reduce original image size if need */
					
					$ImageRealInfo		= getimagesize($ImagePath);
					
					$ImageRealWidth		= $ImageRealInfo[0];
					$ImageRealHeight	= $ImageRealInfo[1];

					$ImageResizeWidth	= FALSE;
					$ImageResizeHeight	= FALSE;

					$ImageNewSize	= PixGallery_ImageCalculateSize($ImagePath, $ImageWidth, $ImageHeight);
					$ImageNewPath	= PixGallery_ImageResize($ImagePath, $ImageNewSize['Width'], $ImageNewSize['Height']);

					$ImageNewPath	= str_replace($PixGlobal_RootWebsite, "", $ImageNewPath);

					/* Set image's new width/height, exspecially if it was previously a % */

					if ($ImageWidth !== FALSE) {
						$TagContents = PixGallery_ImageHtmlAttribute($TagContents, 'width', $ImageNewSize['Width']);
					}
					if ($ImageHeight !== FALSE) {
						$TagContents = PixGallery_ImageHtmlAttribute($TagContents, 'height', $ImageNewSize['Height']);
					}

					if ($ImageNewPath != "")
					{
						$NewTagContents	= PixGallery_ImageHtmlAttribute($TagContents, 'src', $ImageNewPath);

						$ImageOnClick = PixGallery_ImageHtmlAttribute($TagContents, 'onclick');				
						$ImageAlt = PixGallery_ImageHtmlAttribute($TagContents, 'alt');

						$PreviousTagIsLink = FALSE;
						$PreviousTagHtml = substr($Html, 0, ($TagBegin - strlen($TagName) - 1));
						$PreviousTagBegin = strrpos($PreviousTagHtml, "<");

						if ($PreviousTagBegin !== FALSE) 
						{
							if (strtolower($PreviousTagHtml[$PreviousTagBegin + 1]) == 'a') {
								$PreviousTagIsLink = TRUE;
							}
						}

						//$NewTagContents .= ' title="'.$ImageTitle.'"';

						if (($ImageOnClick == FALSE) && ($PreviousTagIsLink == FALSE) && 
							($ImageNoPopup == FALSE) && ($PixGallery_PopupMethod != 'NoPopup'))
						{
							$NewTagContents .= " onclick=\"javascript:PixGallery_ImagePopup"
								.$PixGallery_PopupMethod
								."('$ImageSource', $ImageRealWidth, $ImageRealHeight, "
								."'$ImageAlt', this);\"";
						}


						$NewHtml .= $NewTagContents;
						$TagBeginPrev = $TagEnd;
					}
				} //end of 'if this image has a src'
			} //end of 'if an img tag left'
		}

		$NewHtml .= substr($Html, $TagBeginPrev);

		return $NewHtml; 
	}

	/* ------------------------------------------------------------------------------ */
	/* Photo gallery functions
	/* ------------------------------------------------------------------------------ */

	function PixGallery_PhotoGallery_CollectionFind() 
	{
		global $Collections;
		global $PixGlobal_RootWebsite, $PixGallery_RootPhotos;	
		

		$PhotosDirectory = $PixGlobal_RootWebsite.$PixGallery_RootPhotos;

		if (is_dir($PhotosDirectory))
			{
			if ($DirHandle = opendir($PhotosDirectory)) 
				{
				while (($FileEntry = readdir($DirHandle)) !== FALSE) 
					{
					if ($FileEntry == '.' || $FileEntry == '..')
						continue;

					if (is_dir($PhotosDirectory.$FileEntry))
						{
						$Count = count($Collections) + 1;

						$Collections[$Count]['Path'] = $FileEntry."/";
						$Collections[$Count]['Name'] = $FileEntry;
						}
					}
				}
			else
				PixGallery_PrintError("Error: Unable to open photos path!");

			closedir($DirHandle);
			}
		else
			PixGallery_PrintError("Error: Photos path is invalid!");

		if (count($Collections) == 0)
			PixGallery_PrintError("Error: Photos path should contain subfolders to store each photo gallery!");

		return TRUE;
	}

	function PixGallery_PhotoGallery_CollectionFindImages($CollectionId) 
	{
		global $Collections;
		global $PixGlobal_RootWebsite, $PixGallery_RootPhotos;


		$GalleryPath		= $Collections[$CollectionId]['Path'];
		$CurrentDirectory	= $PixGlobal_RootWebsite.$PixGallery_RootPhotos.$GalleryPath;

		if(is_dir($CurrentDirectory)) 
			{ 
			$DirHandle = opendir($CurrentDirectory); 

			if ($DirHandle == FALSE)
				PixGallery_PrintError("Error: Cannot open directory (".$CurrentDirectory.")");

			while (($Path = readdir($DirHandle)) != FALSE)
				{
				$PathLower = strtolower($CurrentDirectory.$Path);

				if (is_file($CurrentDirectory.$Path) == FALSE)
					continue;
				if ($Path == '.' || $Path == '..')
					continue;

				$MediaFile = $PixGallery_RootPhotos.$GalleryPath.$Path;

				if (strstr($PathLower, ".jpg") || strstr($PathLower, ".gif") || strstr($PathLower, ".png"))
					$Media['Images'][] = $MediaFile;
				}

			closedir($DirHandle); 
			} 
		else
			PixGallery_PrintError("Error: Not a valid directory (".$CurrentDirectory.")");

		return $Media;
	}

	function PixGallery_PhotoGallery_CollectionGetText($CollectionId)
	{
		global $Collections;
		global $PixGlobal_RootWebsite, $PixGallery_RootPhotos;

		if ($CollectionId == FALSE)
			return "";

		$GalleryPath	= $Collections[$CollectionId]['Path'];
		$ReadMe			= $PixGlobal_RootWebsite.$PixGallery_RootPhotos.$GalleryPath."readme.txt";

		if (file_exists($ReadMe) == FALSE)
			return "";

		return "<br />".file_get_contents($ReadMe)."<br /><br />";
	}

	function PixGallery_PhotoGallery_CollectionGetImage($CollectionId, $PhotoId)
	{
		global $Collections;
		global $PixGallery_ImageWidthLarge, $PixGallery_ImageHeightLarge, $PixGlobal_RootWebsite;
		
		$Media				= PixGallery_PhotoGallery_CollectionFindImages($CollectionId);
		$GalleryName		= $Collections[$CollectionId]['Name'];
		$ImagePath			= $PixGlobal_RootWebsite.$Media['Images'][$PhotoId];

		$ImagesCount		= count($Media['Images']);
		$ImageNewSize		= PixGallery_ImageCalculateSizeLarge($ImagePath);

		$NextPhotoId		= $PhotoId + 1;
		$PrevPhotoId		= $PhotoId - 1;

		if ($NextPhotoId >= $ImagesCount)
		{
			$NextPhotoId = 0;
		}
		if ($PrevPhotoId < 0)
		{
			$PrevPhotoId = $ImagesCount - 1;
		}
		$Output = "";

		$Output .= '<p><a href="'.PixGallery_UrlBuild("photo_id").'">View '.$GalleryName.' Collection</a> | '."\n";
		$Output .= '<a href="'.PixGallery_UrlBuild("photo_id", $PrevPhotoId).'">Previous</a> | '."\n";
		$Output .= '<a href="'.PixGallery_UrlBuild("photo_id", $NextPhotoId).'">Next</a></p>'."\n";
		$Output .= '<img src="'.$Media['Images'][$PhotoId].'" width="'.$ImageNewSize['Width'].'" ';
		$Output .= 'class="usePixGallery" alt="" title="(click to enlarge)" />'."\n";
		$Output .= '<p class="photoCount">Photo '.($PhotoId + 1).'/'.$ImagesCount.'</p>'."\n";

		return $Output;
	}

	function PixGallery_PhotoGallery_CollectionGet($CollectionId)
	{
		global $Collections, $PixGlobal_RootWebsite, $PhotoPage;
		global $PixGallery_ImageWidth;

		$PageArray	= null;
		$Media		= PixGallery_PhotoGallery_CollectionFindImages($CollectionId);

		$Output		= "";
		$Output		.= "<a href='".PixGallery_UrlBuild("gallery_id")."'>View Main Photo Collection</a>  ";

		for ($i = 0; $i != count($Media['Images']); $i++)
		{
			$Image			= $Media['Images'][$i];
			$ImageUrl		= PixGallery_UrlBuild("photo_id", $i);
			$ImageNewSize	= PixGallery_ImageCalculateSizeSmall($PixGlobal_RootWebsite.$Image);
			$ImageWidth		= $ImageNewSize['Width'];

			$PageArray[$i]	= "<a href='$ImageUrl'><img src='$Image' width='$ImageWidth' class='usePixGallery' /></a>";		
		}

		$Output .= PixGallery_PhotoGallery_Page($PageArray, "photo_id");

		return $Output;
	}

	function PixGallery_PhotoGallery_CollectionGetAll()
	{
		global $Collections, $PixGlobal_RootWebsite, $GalleryPage;
		global $PixGallery_ImageWidth;

		$PageArray	= null;
		$Output		= "";

		for ($i = 1; $i <= count($Collections); $i++)
		{
			$Media			= PixGallery_PhotoGallery_CollectionFindImages($i);
			$Image			= $Media['Images'][rand(0, count($Media['Images']) - 1)];

			$ImageUrl		= PixGallery_UrlBuild("gallery_id", $i);
			$ImageNewSize	= PixGallery_ImageCalculateSizeSmall($PixGlobal_RootWebsite.$Image);
			$ImageWidth		= $ImageNewSize['Width'];

			$PageData		= "<a href='$ImageUrl'><img src='$Image' width='$ImageWidth' class='usePixGallery' /></a>";
			$PageData		.= "<br /><a href='$ImageUrl'>".$Collections[$i]['Name']."</a>";	
			
			$PageArray[]	= $PageData;
		}

		$Output .= PixGallery_PhotoGallery_Page($PageArray, "gallery_id");
	
		return $Output;
	}

function PixGallery_PhotoGallery_Page($PageArray, $PageId)
{
	global $PixGallery_Columns, $PixGallery_Rows;

	$Output			= "<table>";
	$RowCount		= 0;
	$ColumnCount	= 0;
	$NextPageOffset = 0;
	$PageStartIndex	= 0;
	$PageName		= $PageId."_page";
	$PageIndex		= $_REQUEST[$PageName];
	$Objects		= 0;
	$ObjectsTotal	= count($PageArray);
	$ObjectsIndex	= 0;

	if ($PageIndex == FALSE)
		$PageIndex = 0;

	/* Paging functionality */

	if ($PixGallery_Rows != 0)
		{
		if ($PageIndex != 0)
			$PageStartIndex = (($PixGallery_Columns * $PixGallery_Rows) * $PageIndex) + 1;

		$Output .= "<tr>\n";

		if ($PageIndex != 0)
			{
			$Output .= "<td><a href=".PixGallery_UrlBuild($PageName, $PageIndex - 1).">Previous Page</a></td>\n";
			$NextPageOffset = 1;
			}

		for ($b = 0; $b != $PixGallery_Columns - ($NextPageOffset + 1); $b++)
			$Output .= "<td></td>\n";

		if (($PageStartIndex + ($PixGallery_Columns * $PixGallery_Rows) < count($PageArray)))
			$Output .= "<td align=right><a href=".PixGallery_UrlBuild($PageName, $PageIndex + 1).">Next Page</a></td>\n";

		$Output .= "</tr>\n";
		}

	$ObjectsIndex = $PageStartIndex;

	/* Print page table */

	for ($i = $PageStartIndex; $i != count($PageArray); $i++)
		{
		if ($ColumnCount == 0)
			$Output .= "<tr>\n";

		$Output			.= "<td align=center>".$PageArray[$i]."</td>\n";
		$ColumnCount	+= 1;
		$Objects		+= 1;

		if (($PixGallery_Columns != 0) && ($ColumnCount >= $PixGallery_Columns))
			{
			$Output			.= "</tr>\n";

			$RowCount		+= 1;
			$ColumnCount	= 0;
			}

		if ($PixGallery_Rows != 0 && $RowCount == $PixGallery_Rows)
			break;
		}

	if ($PixGallery_Columns == 0 || $ColumnCount < $PixGallery_Columns)
		$Output .= "</tr>\n";

	$Output .= "</table><br />\n";
	$Output .= "<p class=\"photoCount\">$Objects Photos/Albums ($ObjectsIndex/$ObjectsTotal)</p>\n";

	return $Output;
}

/* Main photo gallery function */

function PixGallery_PhotoGallery($Html) 
{ 
	global $CollectionId, $PhotoId, $Collections;


	$TagName	= "pixgallery"; 
	$TagBegin   = strpos($Html, "<$TagName>");
	$TagEnd     = strpos($Html, "</$TagName>");

	if (($TagBegin !== FALSE) && ($TagEnd !== FALSE)) 
	{
		PixGallery_PhotoGallery_CollectionFind();

		$Text	= substr($Html, 0, $TagBegin); 
		$Output = "";

		if ($PhotoId !== FALSE)
			$Output = PixGallery_PhotoGallery_CollectionGetImage($CollectionId, $PhotoId);
		else
			{
			if ($CollectionId == 0)
				{
				$Output .= $Text;
				$Output .= PixGallery_PhotoGallery_CollectionGetAll();
				}
			else
				{
				$Output .= PixGallery_PhotoGallery_CollectionGetText($CollectionId);
				$Output .= PixGallery_PhotoGallery_CollectionGet($CollectionId);
				}
			}

		$Html = str_replace($Text, "", $Html);
		$Html = str_replace("</$TagName>", "", $Html);
		$Html = str_replace("<$TagName>", $Output, $Html);
	}
	return $Html; 
}

function PixGallery_LayerCode() 
{
	$Output = "\n".'<div id="popuplayer" '
		.'onclick="javascript:PixGallery_ImagePopupLayerClose();" >'."\n"
		.'<img id="popupimage" title="(click to close)" alt="" src="/images/layout/loading.jpg" />'."\n"
		.'</div>'."\n";
	echo $Output;
} 

/* ------------------------------------------------------------------------------ */
/* Administration panel, setting related, filters, etc
/* ------------------------------------------------------------------------------ */

function PixGallery_Options_Save()
{
	$PixGalleryArray = null;

	$Keys = array_keys($GLOBALS);
	for ($i = 0; $i != count($GLOBALS); $i++)
		{
		if (strpos($Keys[$i], "PixGallery_") !== FALSE)
			$PixGalleryArray[str_replace("PixGallery_", "", $Keys[$i])] = $GLOBALS[$Keys[$i]];
		}

	update_option("PixGallery", $PixGalleryArray);
}

function PixGallery_Options_Load()
{
	$PixGalleryArray = get_option("PixGallery");

	if (is_array($PixGalleryArray) == FALSE)
		{
		PixGallery_Options_Save();
		return;
		}

	$Keys = array_keys($PixGalleryArray);

	for ($i = 0; $i != count($PixGalleryArray); $i++)
		{
		$GLOBALS["PixGallery_".$Keys[$i]] = $PixGalleryArray[$Keys[$i]];
		}
}

function PixGallery_Options_Panel()
{
	global $PixGlobal_Version;

	if (isset($_POST['info_update'])) 
		{
		/* Deal with checkboxes */

		$Keys = array_keys($_POST);
		for ($i = 0; $i != count($_POST); $i++)
			{
			if (strpos($Keys[$i], "PixGallery_") !== FALSE)
				{
				$Value = stripslashes($_POST[$Keys[$i]]);

				if ($Value == "on") 
					$Value = '1';

				$GLOBALS[$Keys[$i]] = $Value;
				}
			}

		PixGallery_Options_Save();

		echo "<div class='updated'><p><strong>Settings saved successfully!</strong></p></div>";
		}

	$LatestVersionUrl = "http://www.nathanm.com/projects/pixgallery-version.txt";

	if (ini_get('allow_url_fopen') != '1')
		$LatestVersion = $PixGlobal_Version;
	else
		$LatestVersion = file_get_contents($LatestVersionUrl);

?>

<div class=wrap>
  <form method="post">

    <h2>Photo Gallery Settings </h2>

<?php if ($LatestVersion != $PixGlobal_Version) { ?>
	<p class="error">There is a new version available <?=$LatestVersion?>! You are currently using version <?=$PixGlobal_Version;?>.<br /> To download the latest version please goto <a href="http://www.nathanm.com/index.php/pixgallery/">nathanm.com/index.php/pixgallery</a></p>
<?php } ?>

<fieldset class="options">
<legend>Gallery Layout</legend>
<blockquote>
	<table border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td width="360">Number of columns per gallery page (0 = unlimited)</td>
			<td align=right><input type='text' name='PixGallery_Columns' style='width: 20px;' value='<?=$GLOBALS["PixGallery_Columns"]?>'></td>
		</tr>
	</table>
	<br />
	<table border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td width="360">Number of rows per gallery page (0 = unlimited)</td>
			<td align=right><input type='text' name='PixGallery_Rows' style='width: 20px;' value='<?=$GLOBALS["PixGallery_Rows"]?>'></td>
		</tr>
	</table>
</blockquote>
<legend>Gallery Images</legend>
<blockquote>
	<table border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td width="360">Maximum small thumbnail image size (0 = no max)</td>
			<td align=right><input type='text' name='PixGallery_ImageWidth' style='width: 40px;' value='<?=$GLOBALS["PixGallery_ImageWidth"]?>'> px <input type='text' name='PixGallery_ImageHeight' style='width: 40px;' value='<?=$GLOBALS["PixGallery_ImageHeight"]?>'> px</td>
		</tr>
	</table>
	<br />
	<table border=0 cellpadding=0 cellspacing=0>
		<tr>
			<td width="360">Maximum large thumbnail image size (0 = no max)</td>
			<td align=right><input type='text' name='PixGallery_ImageWidthLarge' style='width: 40px;' value='<?=$GLOBALS["PixGallery_ImageWidthLarge"]?>'> px <input type='text' name='PixGallery_ImageHeightLarge' style='width: 40px;' value='<?=$GLOBALS["PixGallery_ImageHeightLarge"]?>'> px</td>
		</tr>
	</table>
	<br />
	Reduce images in photos path (0 = disabled)
	<br /><br />
	<input type='text' name='PixGallery_ReduceOriginalsWidth' style='width: 40px;' value='<?=$GLOBALS["PixGallery_ReduceOriginalsWidth"]?>'> px <input type='text' name='PixGallery_ReduceOriginalsHeight' style='width: 40px;' value='<?=$GLOBALS["PixGallery_ReduceOriginalsHeight"]?>'> px</td>
	<br /><br />
	If you often upload pictures straight from your digital camera, you can use this option to reduce the actual size of the images in your photos directory. Specify the image width you want your images to reduced to. If you use this option, your photos directory and all subdirectories must have write permissions.
	<br /><br />
	Popup window method
	<br /><br />
	<select name='PixGallery_PopupMethod'>

		<option value='NoPopup'	<?php if ($GLOBALS["PixGallery_PopupMethod"] == 'NoPopup') echo "selected"; ?>>None</option>
		<option value='Window'	<?php if ($GLOBALS["PixGallery_PopupMethod"] == 'Window') echo "selected"; ?>>New Window</option>
		<option value='Layer'	<?php if ($GLOBALS["PixGallery_PopupMethod"] == 'Layer') echo "selected"; ?>>New Layer</option>

	</select>
	<br /><br />
	Normally the large thumbnail images are not the actual width and height of the image file. If you want your users to be able to view the actual image file in a popup window or popup layer when clicking on large thumbnails then this option is for you.
	<br /><br />
	Image style for gallery photos only
	<br /><br />
	<textarea name='PixGallery_ImageStyle' rows=3 style="width: 350px;"><?=$GLOBALS["PixGallery_ImageStyle"]?></textarea>
	<br /><br />
	Image style for all photos
	<br /><br />
	<textarea name='PixGallery_ImageStyleGlobal' rows=3 style="width: 350px;"><?=$GLOBALS["PixGallery_ImageStyleGlobal"]?></textarea>
	<br /><br />
</blockquote>
<legend>Gallery Paths</legend>
<blockquote>
	Photos path
	<br /><br />
	<input type='text' name='PixGallery_RootPhotos' style='width: 350px;' value='<?=$GLOBALS["PixGallery_RootPhotos"]?>'>
	<br /><br />
	Relative path to your photos directory, where each of your galleries are stored in separate subdirectories with images inside of them. The name of your photo galleries are taken from the name of the subdirectories located in the photos directory.
	<br /><br />
	Cache path
	<br /><br />
	<input type='text' name='PixGallery_RootCache' style='width: 350px;' value='<?=$GLOBALS["PixGallery_RootCache"]?>'>
	<br /><br />
	Relative path to your cache directory. This directory is used to store the thumbnail images that are created and must have write permissions.
</blockquote>
</fieldset>

<div class="submit"><input type="submit" name="info_update" value="Apply Options" /></div>

</form>
</div>

<?php
}

function PixGallery_Options_Hook() 
{
    if (function_exists('add_options_page'))
		add_options_page('PixGallery Settings', 'PixGallery', 8, basename(__FILE__), 'PixGallery_Options_Panel');
}

/* ------------------------------------------------------------------------------ */
/* Plugin stuff..
/* ------------------------------------------------------------------------------ */

function PixGallery_Header()
{
	global $PixGallery_ImageStyleGlobal, $PixGallery_ImageStyle;
	global $PixGlobal_RootWebsite;
	
?>
	<!-- Start of PixGallery Global --> 
	<script language='javascript' type='text/javascript' src='<?=get_option('siteurl')?>/wp-content/plugins/pixgallery.js'></script>
	<!-- End of PixGallery Global --> 
<?php
}

add_action('wp_head',		'PixGallery_Header');
add_action('admin_menu',	'PixGallery_Options_Hook');
add_action('wp_footer', 	'PixGallery_LayerCode');
add_filter('the_content',	'PixGallery_PhotoGallery');
add_filter('the_content',	'PixGallery_Image');

?>
